function [acc_test] = PHL_View1(trainset_path, testset_path, xc_path, model_path, pca_dim, pca_minus, sild_dim_kept, c_num, lambda, stop, eps, pre_computing_path)
%% para setting
m = load(trainset_path);
X_Trainset_Target = m.X_Target;      Label_Trainset_Target =  m.Label_Target;
X_Trainset_Query  = m.X_Query;       Label_Trainset_Query = m.Label_Query;
mask_train = strcmp(Label_Trainset_Target, Label_Trainset_Query);

m = load(testset_path);
X_Testset_Target = m.X_Target;      Label_Testset_Target =  m.Label_Target;
X_Testset_Query  = m.X_Query;       Label_Testset_Query = m.Label_Query;
mask_test = strcmp(Label_Testset_Target, Label_Testset_Query);

%% Model Training && Testing
m = load(xc_path);    
XC = m.X;   clear m;   

pca_model_path = [model_path '\Model_PCA_XC_small.mat'];   
%% PCA
if ~exist(pca_model_path,'file')
    PCA(XC, pca_model_path);
end

b_engergy = 1;
energy_ratio = 0.995;    
Y_Trainset_Target   = PCA_Projection(X_Trainset_Target,pca_model_path,pca_dim,b_engergy,energy_ratio);
Y_Trainset_Query    = PCA_Projection(X_Trainset_Query,pca_model_path,pca_dim,b_engergy,energy_ratio);
Y_Testset_Target   = PCA_Projection(X_Testset_Target,pca_model_path,pca_dim,b_engergy,energy_ratio);
Y_Testset_Query    = PCA_Projection(X_Testset_Query,pca_model_path,pca_dim,b_engergy,energy_ratio);
YC         = PCA_Projection(XC,pca_model_path,pca_dim,b_engergy,energy_ratio);


scale = 0.001;
X_Trainset_Target   = NormOne([Y_Trainset_Target; scale * ones(1,size(Y_Trainset_Target,2))]);
X_Trainset_Query    = NormOne([Y_Trainset_Query; scale * ones(1,size(Y_Trainset_Query,2))]);
X_Testset_Target    = NormOne([Y_Testset_Target; scale * ones(1,size(Y_Testset_Target,2))]);
X_Testset_Query     = NormOne([Y_Testset_Query; scale * ones(1,size(Y_Testset_Query,2))]);
XC                  = NormOne([YC; scale * ones(1,size(YC,2))]);
    
phl_model_path = [pre_computing_path '\view1_c_' num2str(c_num) '_lambda_' num2str(lambda) '_stop_' num2str(stop) '.mat'];
pre_path = [pre_computing_path '\view1_precomputing.mat'];

if~exist(phl_model_path,'file')
    MaxIter = 100;
    B = PHL(pre_path,XC,X_Trainset_Target,X_Trainset_Query,mask_train,c_num,lambda,stop,MaxIter,phl_model_path,eps);
else
    m = load(phl_model_path);
    B = m.B;
end
            
Y_Trainset_Target = ProjectionToSVM(XC,B,X_Trainset_Target);
Y_Trainset_Query = ProjectionToSVM(XC,B,X_Trainset_Query);
Y_Testset_Target = ProjectionToSVM(XC,B,X_Testset_Target);
Y_Testset_Query = ProjectionToSVM(XC,B,X_Testset_Query);

pca_model_path_sild = [model_path '\Model_SILD_PCA_view1.mat'];
lda_model_path_sild = [model_path '\Model_SILD_LDA_view1.mat'];  
Y_Trainset = [Y_Trainset_Target Y_Trainset_Query];
PCA(Y_Trainset,pca_model_path_sild);
SILD(Y_Trainset_Target,Y_Trainset_Query,mask_train,pca_model_path_sild,pca_dim,pca_minus,pca_dim,lda_model_path_sild,0,sild_dim_kept,1);

%% Testing
sim_train = cal_sim_one_model(Y_Trainset_Target,Y_Trainset_Query,lda_model_path_sild,1);
[acc_train threshold] = Cal_One_Block_ACC(sim_train,mask_train);
fprintf('trainset view1: %f %f\n',acc_train, threshold);

sim_test = cal_sim_one_model(Y_Testset_Target,Y_Testset_Query,lda_model_path_sild,1);
acc_test = Cal_ACC(sim_test,mask_test,threshold);
[acc_best threshold_best] = Cal_One_Block_ACC(sim_test,mask_test);
fprintf('testset view1: %f %f, best :%f %f \n', acc_test, threshold, acc_best, threshold_best);