function [mean_acc se_acc] = PHL_View2(testset_path,model_path,result_path,sild_pca_dim,pca_minus,sild_dim_kept,b_wei,cluster_num,lambda,stop,eps,xc_path,pre_computing_path)
%% para setting
m = load(testset_path);
X_Target = m.X_Target;      Label_Target =  m.Label_Target;
X_Query  = m.X_Query;       Label_Query = m.Label_Query;
Mask = strcmp(Label_Target, Label_Query);

%% Model Training && Testing
one_fold_len = 600; num_fold = 10;
Index = zeros(1,one_fold_len*num_fold,'int32');
Acc = [];

m = load(xc_path);    
XC = m.X;   clear m;   

pca_model_path = [model_path '\Model_PCA_XC_small.mat'];   
%% PCA
if ~exist(pca_model_path,'file')
    PCA(XC, pca_model_path);
end

b_engergy = 1;
energy_ratio = 0.995;    
Y_Target   = PCA_Projection(X_Target,pca_model_path,sild_pca_dim,b_engergy,energy_ratio);
Y_Query    = PCA_Projection(X_Query,pca_model_path,sild_pca_dim,b_engergy,energy_ratio);
YC         = PCA_Projection(XC,pca_model_path,sild_pca_dim,b_engergy,energy_ratio);

scale = 0.001;
X_Target   = NormOne([Y_Target; scale * ones(1,size(Y_Target,2))]);
X_Query    = NormOne([Y_Query; scale * ones(1,size(Y_Query,2))]);
XC                  = NormOne([YC; scale * ones(1,size(YC,2))]);
    

for i=1:num_fold
    index = Index;
    index((i-1)*one_fold_len+1:i*one_fold_len) = 1;
    mask_train = Mask(index==0);
    mask_test = Mask(index==1);
    
    X_Trainset_Target = X_Target(:,index==0);   %Label_Trainset_Target = Label_Target(index==0);
    X_Trainset_Query = X_Query(:,index==0);     %Label_Trainset_Query = Label_Query(index == 0);
    X_Testset_Target = X_Target(:,index==1);    %Label_Testset_Target = Label_Target(index == 1);
    X_Testset_Query = X_Query(:,index==1);      %Label_Testset_Query = Label_Query(index == 1);
   
    phl_model_path = [pre_computing_path '\fold_' num2str(i) '_cluster_' num2str(cluster_num) '_lambda_' num2str(lambda) '_stop_' num2str(stop) '.mat'];
    sw_path = [pre_computing_path '\fold_' num2str(i) '_sw.mat'];

    if ~exist(phl_model_path,'file')
        MaxIter = 100;
        B = PHL(sw_path,XC,X_Trainset_Target,X_Trainset_Query,mask_train,cluster_num,lambda,stop,MaxIter,phl_model_path,eps);
    else
        m = load(phl_model_path);
        B = m.B;
    end
            
    Y_Trainset_Target = ProjectionToSVM(XC,B,X_Trainset_Target);
    Y_Trainset_Query = ProjectionToSVM(XC,B,X_Trainset_Query);
    Y_Testset_Target = ProjectionToSVM(XC,B,X_Testset_Target);
    Y_Testset_Query = ProjectionToSVM(XC,B,X_Testset_Query);
    
    %% PCA & LDA
    pca_model_path_i = [model_path '\Model_SILD_PCA_' num2str(i) '.mat'];
    lda_model_path_i = [model_path '\Model_SILD_LDA' num2str(i) '.mat'];
    
    Y_Trainset = [Y_Trainset_Target Y_Trainset_Query];
    PCA(Y_Trainset,pca_model_path_i);   
    SILD(Y_Trainset_Target,Y_Trainset_Query,mask_train,pca_model_path_i,sild_pca_dim,pca_minus,sild_pca_dim,lda_model_path_i,0,sild_dim_kept,b_wei);

    %% Testing
    sim_train = cal_sim_one_model(Y_Trainset_Target,Y_Trainset_Query,lda_model_path_i,1);
    [acc_train threshold] = Cal_One_Block_ACC(sim_train,mask_train);
    fprintf('trainset view2 fold %d: %f %f\n',i,acc_train, threshold);

    sim_test = cal_sim_one_model(Y_Testset_Target,Y_Testset_Query,lda_model_path_i,1);
    [acc_test] = Cal_ACC(sim_test,mask_test,threshold);
    [acc_best threshold_best] = Cal_One_Block_ACC(sim_test,mask_test);
    fprintf('testset view2 fold %d: %f %f, best :%f %f \n',i, acc_test, threshold, acc_best, threshold_best);

    Acc = [Acc acc_test];
    result_path_i = [result_path '\mat\Sw_', num2str(sild_dim_kept) '_fold_' num2str(i) '.mat'];
    save(result_path_i,'acc_train','acc_test','mask_test');
end

mean_acc = mean(Acc);
se_acc = std(Acc)/sqrt(10);