function Script_on_view1_Intensity
diary('output_view1.txt'); diary on;
trainset_path = '..\DB\Intensity\lfw_intensity_view1_train.mat';
testset_path = '..\DB\Intensity\lfw_intensity_view1_test.mat';
xc_path = '..\DB\Intensity\lfw_intensity_xc_3000.mat';

model_path = '..\Model\Intensity_view1';  pmkdir(model_path); 
result_path = '..\Result\Intensity_view1';  pmkdir(result_path);
pre_computing_path = [model_path '\PreComputing'];      pmkdir(pre_computing_path);

max_acc = 0;
pca_minus=0;
eps = 0.001;
for c_num  = 400%[400 500 600 300]
    for lambda = [8 9 10 11 12]
            result_path = ['..\Result\Intensity_view1\PHL_c_' num2str(c_num) '_lambda_' num2str(lambda)  '_view1'];  pmkdir(result_path);   pmkdir([result_path '\mat']);
            pre_computing_path = [model_path '\PreComputing'];      pmkdir(pre_computing_path);
            p = fopen([result_path '\result_phl_view1.txt'],'wt');

            for stop = [0.05 0.08 0.1 0.3 0.5] %0.01 0.03 
                for pca_dim = c_num
                    for dim_kept = pca_dim:-100:100
                        [acc_test] = PHL_View1(trainset_path, testset_path, xc_path, model_path, pca_dim, pca_minus, dim_kept, c_num, lambda, stop, eps, pre_computing_path);
                        if acc_test>max_acc
                            max_acc = acc_test;
                            opt_sild_pca_dim = pca_dim;
                            opt_sild_sw_dim = dim_kept;
                            opt_stop = stop;
                            opt_c_num = c_num;
                            opt_lambda = lambda;
                            save('..\Model\opt_para.mat','max_acc', 'opt_sild_pca_dim', 'opt_sild_pca_dim', 'opt_sild_sw_dim', 'opt_stop', 'opt_c_num', 'opt_lambda');
                        end


                        fprintf(p,'lambda:%f stop:%f dim_del %d pca_dim:%d : acc_test: %f, max_acc:%f, pca_dim:%d dim_kept:%d stop:%f lambda:%f c:%d\n',lambda,stop,dim_kept,pca_dim,acc_test,max_acc,opt_sild_pca_dim,opt_sild_sw_dim,opt_stop,opt_lambda,opt_c_num); 
                        fprintf('lambda:%f stop:%f dim_del %d pca_dim:%d : acc_test: %f, max_acc:%f, pca_dim:%d dim_kept:%d stop:%f lambda:%f c;%d\n',lambda,stop,dim_kept,pca_dim,acc_test,max_acc,opt_sild_pca_dim,opt_sild_sw_dim,opt_stop,opt_lambda,opt_c_num); 

                    end
                end
            end
            fclose(p);
    end
end
