function SILD(X_Trainset_Target,X_Trainset_Query,mask,pca_model_path,pca_dim,pca_minus,lda_dim,lda_model_path,b_energy,dim_del,b_wei)
%% *********** PCA Projection *************************************
m = load(pca_model_path);
x_mean = m.x_mean;
x_var = m.x_var;
if pca_dim == -1
    pca_dim = size(m.W_pca,2);
end
if pca_dim > (size(m.W_pca,2) - pca_minus)
    fprintf('this pca model only have %d dims, cannot reach %d\n',(size(m.W_pca,2) - pca_minus),pca_dim);
    pca_dim = (size(m.W_pca,2) - pca_minus);
end
W_pca = m.W_pca(:,pca_minus+1:pca_dim);

[dim pca_dim]= size(W_pca); 

Y_Trainset_Target  = W_pca' * ZeroMeanOneVar(X_Trainset_Target,x_mean,x_var);
Y_Trainset_Query  = W_pca' * ZeroMeanOneVar(X_Trainset_Query,x_mean,x_var);

% mask = strcmp(Label_Trainset_Target, Label_Trainset_Query);
index_pos = find(mask == 1);
index_neg = find(mask == 0);


%% Cal Sw & Sb
Delta_Pos = Y_Trainset_Target(:,index_pos) - Y_Trainset_Query(:,index_pos);

if b_wei ==1
    Sim_Neg = diag(CalSim(Y_Trainset_Target(:,index_neg),Y_Trainset_Query(:,index_neg))); % columne vector
%     Sim_Neg = sqrt( 2 ./ (Sim_Neg + 1));
    Sim_Neg = sqrt( (0.5*(Sim_Neg + 1)));
%     Sim_Neg = sqrt( 1./ (1+ exp(-1*(Sim_Neg + 1))));
    S = repmat(Sim_Neg',pca_dim,1);
    Delta_Neg = (Y_Trainset_Target(:,index_neg) .* S) - (Y_Trainset_Query(:,index_neg).*S);
else
    Delta_Neg = (Y_Trainset_Target(:,index_neg)) - (Y_Trainset_Query(:,index_neg));
end


Sw = Delta_Pos * Delta_Pos';
Sb = Delta_Neg * Delta_Neg';

%% SVD

[h A H]= svd(Sw);

% q = 5; r = floor(pca_dim*0.9);
% 
% for i=1:q
%     A(i,i) = 1 / sqrt(A(i,i));
% end
% for i=q+1:r
%     A(i,i) = 1 / sqrt(A(i,i));
% end
for i=1:size(A,2)
    A(i,i) = 1 / sqrt(A(i,i));
end

M1 = H * A(:,1:dim_del);
M4 = M1' * Sb * M1;
[u EV U] = svd(M4);

EE = M1 * U;

eig_val_unsort = diag(EV);
V = EE;

[eigen_value,index] = sort(eig_val_unsort, 'descend');

% kept energy
energy = sum(eigen_value);
dim = size(Sw,1);
lda_dim = dim_del;
if b_energy == 1
    for i=1:dim
        kept_energy = sum(eigen_value(1:i));
        if kept_energy > energy*0.98
            lda_dim = i;
            break;
        end
    end
end
%     lda_dim = 170;
fprintf('SILD dim: %d\n',lda_dim);
W_lda = zeros(dim,lda_dim);
for i = 1: lda_dim
    v =  V(: , index(i));
    v = v / norm(v);
    W_lda(:, i ) =v;
end

%% spectral regression
% W_lda = (inv(Y_sw*Y_sw'+1))'*Y_sw*Y_sw'*W_lda;
save(lda_model_path, 'x_mean', 'x_var', 'W_pca', 'W_lda','lda_dim');
fprintf('SILD Weighting Model Finished\n');